/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */

/* auto-generated by NAPI-RS */

const { existsSync, readFileSync } = require('fs')
const { join } = require('path')

const { platform, arch } = process

let nativeBinding = null
let localFileExisted = false
let loadError = null

function isMusl() {
  // For Node 10
  if (!process.report || typeof process.report.getReport !== 'function') {
    try {
      const lddPath = require('child_process').execSync('which ldd').toString().trim()
      return readFileSync(lddPath, 'utf8').includes('musl')
    } catch (e) {
      return true
    }
  } else {
    const { glibcVersionRuntime } = process.report.getReport().header
    return !glibcVersionRuntime
  }
}

switch (platform) {
  case 'android':
    switch (arch) {
      case 'arm64':
        localFileExisted = existsSync(join(__dirname, 'system-prompt-composer.android-arm64.node'))
        try {
          if (localFileExisted) {
            nativeBinding = require('./system-prompt-composer.android-arm64.node')
          } else {
            nativeBinding = require('system-prompt-composer-android-arm64')
          }
        } catch (e) {
          loadError = e
        }
        break
      case 'arm':
        localFileExisted = existsSync(join(__dirname, 'system-prompt-composer.android-arm-eabi.node'))
        try {
          if (localFileExisted) {
            nativeBinding = require('./system-prompt-composer.android-arm-eabi.node')
          } else {
            nativeBinding = require('system-prompt-composer-android-arm-eabi')
          }
        } catch (e) {
          loadError = e
        }
        break
      default:
        throw new Error(`Unsupported architecture on Android ${arch}`)
    }
    break
  case 'win32':
    switch (arch) {
      case 'x64':
        localFileExisted = existsSync(
          join(__dirname, 'system-prompt-composer.win32-x64-msvc.node')
        )
        try {
          if (localFileExisted) {
            nativeBinding = require('./system-prompt-composer.win32-x64-msvc.node')
          } else {
            nativeBinding = require('system-prompt-composer-win32-x64-msvc')
          }
        } catch (e) {
          loadError = e
        }
        break
      case 'ia32':
        localFileExisted = existsSync(
          join(__dirname, 'system-prompt-composer.win32-ia32-msvc.node')
        )
        try {
          if (localFileExisted) {
            nativeBinding = require('./system-prompt-composer.win32-ia32-msvc.node')
          } else {
            nativeBinding = require('system-prompt-composer-win32-ia32-msvc')
          }
        } catch (e) {
          loadError = e
        }
        break
      case 'arm64':
        localFileExisted = existsSync(
          join(__dirname, 'system-prompt-composer.win32-arm64-msvc.node')
        )
        try {
          if (localFileExisted) {
            nativeBinding = require('./system-prompt-composer.win32-arm64-msvc.node')
          } else {
            nativeBinding = require('system-prompt-composer-win32-arm64-msvc')
          }
        } catch (e) {
          loadError = e
        }
        break
      default:
        throw new Error(`Unsupported architecture on Windows: ${arch}`)
    }
    break
  case 'darwin':
    localFileExisted = existsSync(join(__dirname, 'system-prompt-composer.darwin-universal.node'))
    try {
      if (localFileExisted) {
        nativeBinding = require('./system-prompt-composer.darwin-universal.node')
      } else {
        nativeBinding = require('system-prompt-composer-darwin-universal')
      }
      break
    } catch {}
    switch (arch) {
      case 'x64':
        localFileExisted = existsSync(join(__dirname, 'system-prompt-composer.darwin-x64.node'))
        try {
          if (localFileExisted) {
            nativeBinding = require('./system-prompt-composer.darwin-x64.node')
          } else {
            nativeBinding = require('system-prompt-composer-darwin-x64')
          }
        } catch (e) {
          loadError = e
        }
        break
      case 'arm64':
        localFileExisted = existsSync(
          join(__dirname, 'system-prompt-composer.darwin-arm64.node')
        )
        try {
          if (localFileExisted) {
            nativeBinding = require('./system-prompt-composer.darwin-arm64.node')
          } else {
            nativeBinding = require('system-prompt-composer-darwin-arm64')
          }
        } catch (e) {
          loadError = e
        }
        break
      default:
        throw new Error(`Unsupported architecture on macOS: ${arch}`)
    }
    break
  case 'freebsd':
    if (arch !== 'x64') {
      throw new Error(`Unsupported architecture on FreeBSD: ${arch}`)
    }
    localFileExisted = existsSync(join(__dirname, 'system-prompt-composer.freebsd-x64.node'))
    try {
      if (localFileExisted) {
        nativeBinding = require('./system-prompt-composer.freebsd-x64.node')
      } else {
        nativeBinding = require('system-prompt-composer-freebsd-x64')
      }
    } catch (e) {
      loadError = e
    }
    break
  case 'linux':
    switch (arch) {
      case 'x64':
        if (isMusl()) {
          localFileExisted = existsSync(
            join(__dirname, 'system-prompt-composer.linux-x64-musl.node')
          )
          try {
            if (localFileExisted) {
              nativeBinding = require('./system-prompt-composer.linux-x64-musl.node')
            } else {
              nativeBinding = require('system-prompt-composer-linux-x64-musl')
            }
          } catch (e) {
            loadError = e
          }
        } else {
          localFileExisted = existsSync(
            join(__dirname, 'system-prompt-composer.linux-x64-gnu.node')
          )
          try {
            if (localFileExisted) {
              nativeBinding = require('./system-prompt-composer.linux-x64-gnu.node')
            } else {
              nativeBinding = require('system-prompt-composer-linux-x64-gnu')
            }
          } catch (e) {
            loadError = e
          }
        }
        break
      case 'arm64':
        if (isMusl()) {
          localFileExisted = existsSync(
            join(__dirname, 'system-prompt-composer.linux-arm64-musl.node')
          )
          try {
            if (localFileExisted) {
              nativeBinding = require('./system-prompt-composer.linux-arm64-musl.node')
            } else {
              nativeBinding = require('system-prompt-composer-linux-arm64-musl')
            }
          } catch (e) {
            loadError = e
          }
        } else {
          localFileExisted = existsSync(
            join(__dirname, 'system-prompt-composer.linux-arm64-gnu.node')
          )
          try {
            if (localFileExisted) {
              nativeBinding = require('./system-prompt-composer.linux-arm64-gnu.node')
            } else {
              nativeBinding = require('system-prompt-composer-linux-arm64-gnu')
            }
          } catch (e) {
            loadError = e
          }
        }
        break
      case 'arm':
        if (isMusl()) {
          localFileExisted = existsSync(
            join(__dirname, 'system-prompt-composer.linux-arm-musleabihf.node')
          )
          try {
            if (localFileExisted) {
              nativeBinding = require('./system-prompt-composer.linux-arm-musleabihf.node')
            } else {
              nativeBinding = require('system-prompt-composer-linux-arm-musleabihf')
            }
          } catch (e) {
            loadError = e
          }
        } else {
          localFileExisted = existsSync(
            join(__dirname, 'system-prompt-composer.linux-arm-gnueabihf.node')
          )
          try {
            if (localFileExisted) {
              nativeBinding = require('./system-prompt-composer.linux-arm-gnueabihf.node')
            } else {
              nativeBinding = require('system-prompt-composer-linux-arm-gnueabihf')
            }
          } catch (e) {
            loadError = e
          }
        }
        break
      case 'riscv64':
        if (isMusl()) {
          localFileExisted = existsSync(
            join(__dirname, 'system-prompt-composer.linux-riscv64-musl.node')
          )
          try {
            if (localFileExisted) {
              nativeBinding = require('./system-prompt-composer.linux-riscv64-musl.node')
            } else {
              nativeBinding = require('system-prompt-composer-linux-riscv64-musl')
            }
          } catch (e) {
            loadError = e
          }
        } else {
          localFileExisted = existsSync(
            join(__dirname, 'system-prompt-composer.linux-riscv64-gnu.node')
          )
          try {
            if (localFileExisted) {
              nativeBinding = require('./system-prompt-composer.linux-riscv64-gnu.node')
            } else {
              nativeBinding = require('system-prompt-composer-linux-riscv64-gnu')
            }
          } catch (e) {
            loadError = e
          }
        }
        break
      case 's390x':
        localFileExisted = existsSync(
          join(__dirname, 'system-prompt-composer.linux-s390x-gnu.node')
        )
        try {
          if (localFileExisted) {
            nativeBinding = require('./system-prompt-composer.linux-s390x-gnu.node')
          } else {
            nativeBinding = require('system-prompt-composer-linux-s390x-gnu')
          }
        } catch (e) {
          loadError = e
        }
        break
      default:
        throw new Error(`Unsupported architecture on Linux: ${arch}`)
    }
    break
  default:
    throw new Error(`Unsupported OS: ${platform}, architecture: ${arch}`)
}

if (!nativeBinding) {
  if (loadError) {
    throw loadError
  }
  throw new Error(`Failed to load native binding`)
}

const { 
  composeSystemPromptWithPromptsDir,
  listAvailableDomainsWithPromptsDir,
  listAvailableBehaviorsWithPromptsDir,
  isAvailable, 
  getStatus: nativeGetStatus 
} = nativeBinding

// Minimal convenience functions for data marshaling only
function composeSystemPrompt(request) {
  const requestJson = typeof request === 'string' ? request : JSON.stringify(request);
  const promptsDir = join(__dirname, 'prompts');
  const responseJson = composeSystemPromptWithPromptsDir(requestJson, promptsDir);
  return JSON.parse(responseJson);
}

function getStatus() {
  const statusJson = nativeGetStatus();
  return JSON.parse(statusJson);
}

function listAvailableDomains() {
  const promptsDir = join(__dirname, 'prompts');
  return listAvailableDomainsWithPromptsDir(promptsDir);
}

function listAvailableBehaviors() {
  const promptsDir = join(__dirname, 'prompts');
  return listAvailableBehaviorsWithPromptsDir(promptsDir);
}

// Export the minimal API
module.exports = {
  composeSystemPrompt,
  listAvailableDomains,
  listAvailableBehaviors,
  isAvailable,
  getStatus
}
